;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%  Product Title  : st7541 128x128 Mode FOR IIC                         %
;%  Start  Date    : 12/30/2006                                          %
;%  Finish Date    : Bily                                                %
;%                                                                       %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;;~~~~~~~~~~~~ I/O BIT MAP ~~~~~~~~~~~~~~~~~~~~~~~~
SCL             REG     P1.7            ;
SDA             REG     P1.6            ;
RES             REG     P3.5            ;
;;~~~~~~~~~~~~~ DATA DEFINE ~~~~~~~~~~~~~~~~~~~~~~~~
I2C_DATA	EQU	2BH
STACK           EQU     6FH
;;~~~~~~~~~~~~~ VECTOR DEFINE ~~~~~~~~~~~~~~~~~~~~~~
                ORG     0000H           ; RESET VECTOR
                LJMP    SYS_RESET       ;
                ORG     0003H           ; INT0 VECTOR
                RETI                    ;
                ORG     000BH           ; TIMER0 VECTOR
                RETI                    ;
                ORG     0013H           ; INT1 VECTOR
                RETI                    ;
                ORG     001BH           ; TIMER1 VECTOR
                RETI                    ;
                ORG     0023H           ; RI/TI VECTOR
                RETI                    ;
                ORG     002BH           ; TIMER2 VECTOR
                RETI                    ;
;#########################################################################
;#####                    8051 SYSTEM Reset program start            #####
;#########################################################################
SYS_RESET:
                MOV     SP,#STACK       ; INITIAL STACK POINTER
                MOV     IE,#00H         ;
                MOV     IP,#00H         ;
                MOV     PSW,#00H        ;
                MOV     TMOD,#00000000B ;
                MOV     TL0,#<(65535-8300);
                MOV     TH0,#>(65535-8300);
                ;-----------------------;
                MOV     P1,#11111111B   ;
                MOV     P3,#11111111B   ;
                CALL    DELAY_10MS      ;
                ;SETB    RES            ;
                ;CALL    DELAY_10MS     ; 
                CLR     RES             ;
                CALL    DELAY_10MS      ;           
                SETB    RES             ;
                CALL    DELAY_10MS      ; 
                ;-----------------------;
                SETB    TR0             ;
                SETB    ET0             ;
;#########################################################################
                CALL    FILL_RAM_00     ;
                CALL    INIT_ST7541     ;
                ;=======================;
MAIN:					;
                CALL    FILL_RAM_FF	;
                CALL    DELAY_1SEC	;
                JB      P3.7,$		;
                CALL    DELAY_1SEC	;
                ;CALL    FILL_RAM_AA	;
                ;CALL    DELAY_1SEC	;
                ;JB      P3.7,$		;
                ;CALL    DELAY_1SEC	;
                MOV     DPTR,#pp1       ;
                CALL    SHOW_128_128    ;               
                CALL    DELAY_1SEC	;
                JB      P3.7,$		;
                CALL    DELAY_1SEC	;
					;
		CALL	SLEEP_IN	;
                CALL    DELAY_1SEC	;
                JB      P3.7,$		;
                CALL    DELAY_1SEC	;
                			;
                CALL	SLEEP_OUT	;
                CALL    DELAY_1SEC	;
                JB      P3.7,$		;
                CALL    DELAY_1SEC	;
                			;
                JMP	MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            
INIT_ST7541_1:	
		CALL	START_1
				
		MOV     A,#AEH          ;
                CALL    WR_INST_1         ;

	        MOV     A,#A0H          ;/*ADC=normal*/
                CALL    WR_INST_1         ;

                MOV     A,#0c8H         ;/*SHL=reverse*/
                CALL    WR_INST_1         ;
                
                MOV     A,#044H         ;/*COM0*/
                CALL    WR_INST_1         ;
                
                MOV     A,#00H          ;/*Set initial com12*/   ;0bh
                CALL    WR_INST_1         ;
               ;;=======================;;
                MOV     A,#040H         ;/*SET INITIAL DISPLAY LINE REGISTER*/
                CALL    WR_INST_1         ;
                MOV     A,#000H         ;/*SET INITIAL DISPLAY LINE TO 00*/
                CALL    WR_INST_1         ;
                
                MOV     A,#0b0H         ;
                CALL    WR_INST_1         ;
               
                MOV     A,#038H         ;/set mode frequency 
                CALL    WR_INST_1         ;
                MOV     A,#80H         ;/*75hz*/
                CALL    WR_INST_1         ;
                ;;======================;;               
                MOV     A,#027H         ;/* 7.2 */    bad
                ;;MOV     A,#025H         ;/* 5.8 */    good
                CALL    WR_INST_1         ;               
                
                MOV     A,#081H         ;/*SELECT ELECTRONIC VOLUME REGISTER */
                CALL    WR_INST_1         ;
                MOV     A,#029H         ; V0= 12.8V
                CALL    WR_INST_1         ;               
                
                MOV     A,#057H         ;/*BIAS=12*/   bad
                ; MOV     A,#053H         ;/*BIAS=8*/  good
                CALL    WR_INST_1         ;               
                ;;======================;;                             
                MOV     A,#04cH         ;/*SET N-LINE INVERSION 4c */
                CALL    WR_INST_1         ;
                MOV     A,#000H         ;
                CALL    WR_INST_1         ;
                MOV     A,#093H         ; /* 4FRC */  /*PWM 15*/
                CALL    WR_INST_1         ;                            
               ;========================;; /* color setting */
                MOV     A,#088H         ;
                CALL    WR_INST_1         ;
                MOV     A,#000H         ;
                CALL    WR_INST_1         ;
                MOV     A,#089H         ;
                CALL    WR_INST_1         ;
                MOV     A,#000H         ;
                CALL    WR_INST_1         ;
                                        ;
                MOV     A,#08AH         ;
                CALL    WR_INST_1         ;
                MOV     A,#099H         ;
                CALL    WR_INST_1         ;
                MOV     A,#08BH         ;
                CALL    WR_INST_1         ;
                MOV     A,#099H         ; 
                CALL    WR_INST_1         ;
                                        ;
                MOV     A,#08CH         ;
                CALL    WR_INST_1         ;
                MOV     A,#0DDH         ;
                CALL    WR_INST_1         ;
                MOV     A,#08DH         ;
                CALL    WR_INST_1         ;
                MOV     A,#0DDH         ;
                CALL    WR_INST_1         ;
                                        ;
                MOV     A,#08EH         ;
                CALL    WR_INST_1         ;
                MOV     A,#0FFH         ;
                CALL    WR_INST_1         ;
                MOV     A,#08FH         ;
                CALL    WR_INST_1         ;
                MOV     A,#0FFH         ;
                CALL    WR_INST_1         ;
               ;========================;               
                MOV     A,#064H         ;/*Booster 3 TIME*/
                CALL    WR_INST_1         ;
                CALL    DELAY_10MS
                CALL    DELAY_10MS                
                                                                
                MOV     A,#00101100B    ;POWER CONTROL VC=1
                CALL    WR_INST_1         ;                
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                                
                MOV     A,#65H          ;/*Booster 4 TIME*/
                CALL    WR_INST_1         ;
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                
                MOV     A,#66H          ;/*Booster 5 TIME*/
                CALL    WR_INST_1         ;
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                                        
                MOV     A,#00101110B    ;POWER CONTROL VC=1 VR=1
                CALL    WR_INST_1         ;
                CALL    DELAY_10MS      ;
                CALL    DELAY_10MS           
                                
                MOV     A,#00101111B    ;POWER CONTROL VC=1 VR=1 VF=1
                CALL    WR_INST_1         ;
                CALL    DELAY_10MS
                CALL    DELAY_10MS            
                              
                MOV     A,#ABH         ;/*OSC ON*/
                CALL    WR_INST_1         ;
               
                MOV     A,#A6H         ;/*reverse display on/off*/
                CALL    WR_INST_1         ;/*display normal*/
                
                MOV     A,#A8H         ;/*powersave mode*/
                CALL    WR_INST_1         ;/normal
                
                ;CALL    FILL_RAM_00     ;/*clear display*/
                
                MOV     A,#A2H         ;/*disable icon row*/
                CALL    WR_INST_1         ;
                
                MOV     A,#AFH         ;/*Display on*/
                CALL    WR_INST_1         ;
                
                MOV     A,#A4H         ;/*full off*/?????????????
                CALL    WR_INST_1         ;/*entire display on/off*/
                
                CALL	STOP_1
                                 
                RET                     ;
;;======================================================
INIT_ST7541:					
		MOV     A,#AEH          ;
                CALL    WR_INST         ;

	        MOV     A,#A0H          ;/*ADC=normal*/
                CALL    WR_INST         ;

                MOV     A,#0c8H         ;/*SHL=reverse*/
                CALL    WR_INST         ;
                
                MOV     A,#044H         ;/*COM0*/
                CALL    WR_INST         ;
                
                MOV     A,#00H          ;/*Set initial com12*/   ;0bh
                CALL    WR_INST         ;
               ;;=======================;;
                MOV     A,#040H         ;/*SET INITIAL DISPLAY LINE REGISTER*/
                CALL    WR_INST         ;
                MOV     A,#000H         ;/*SET INITIAL DISPLAY LINE TO 00*/
                CALL    WR_INST         ;
                
                MOV     A,#0b0H         ;
                CALL    WR_INST         ;
               
                MOV     A,#038H         ;/set mode frequency 
                CALL    WR_INST         ;
                MOV     A,#80H         ;/*75hz*/
                CALL    WR_INST         ;
                ;;======================;;               
                MOV     A,#027H         ;/* 7.2 */    bad
                ;;MOV     A,#025H         ;/* 5.8 */    good
                CALL    WR_INST         ;               
                
                MOV     A,#081H         ;/*SELECT ELECTRONIC VOLUME REGISTER */
                CALL    WR_INST         ;
                MOV     A,#029H         ; V0= 12.8V
                CALL    WR_INST         ;               
                
                MOV     A,#057H         ;/*BIAS=12*/   bad
                ; MOV     A,#053H         ;/*BIAS=8*/  good
                CALL    WR_INST         ;               
                ;;======================;;                             
                MOV     A,#04cH         ;/*SET N-LINE INVERSION 4c */
                CALL    WR_INST         ;
                MOV     A,#000H         ;
                CALL    WR_INST         ;
                MOV     A,#093H         ; /* 4FRC */  /*PWM 15*/
                CALL    WR_INST         ;                            
               ;========================;; /* color setting */
                MOV     A,#088H         ;
                CALL    WR_INST         ;
                MOV     A,#000H         ;
                CALL    WR_INST         ;
                MOV     A,#089H         ;
                CALL    WR_INST         ;
                MOV     A,#000H         ;
                CALL    WR_INST         ;
                                        ;
                MOV     A,#08AH         ;
                CALL    WR_INST         ;
                MOV     A,#099H         ;
                CALL    WR_INST         ;
                MOV     A,#08BH         ;
                CALL    WR_INST         ;
                MOV     A,#099H         ; 
                CALL    WR_INST         ;
                                        ;
                MOV     A,#08CH         ;
                CALL    WR_INST         ;
                MOV     A,#0DDH         ;
                CALL    WR_INST         ;
                MOV     A,#08DH         ;
                CALL    WR_INST         ;
                MOV     A,#0DDH         ;
                CALL    WR_INST         ;
                                        ;
                MOV     A,#08EH         ;
                CALL    WR_INST         ;
                MOV     A,#0FFH         ;
                CALL    WR_INST         ;
                MOV     A,#08FH         ;
                CALL    WR_INST         ;
                MOV     A,#0FFH         ;
                CALL    WR_INST         ;
               ;========================;               
                MOV     A,#064H         ;/*Booster 3 TIME*/
                CALL    WR_INST         ;
                CALL    DELAY_10MS
                CALL    DELAY_10MS                
                                                                
                MOV     A,#00101100B    ;POWER CONTROL VC=1
                CALL    WR_INST         ;                
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                                
                MOV     A,#65H          ;/*Booster 4 TIME*/
                CALL    WR_INST         ;
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                
                MOV     A,#66H          ;/*Booster 5 TIME*/
                CALL    WR_INST         ;
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                CALL    DELAY_10MS
                                        
                MOV     A,#00101110B    ;POWER CONTROL VC=1 VR=1
                CALL    WR_INST         ;
                CALL    DELAY_10MS      ;
                CALL    DELAY_10MS           
                                
                MOV     A,#00101111B    ;POWER CONTROL VC=1 VR=1 VF=1
                CALL    WR_INST         ;
                CALL    DELAY_10MS
                CALL    DELAY_10MS            
                              
                MOV     A,#ABH         ;/*OSC ON*/
                CALL    WR_INST         ;
               
                MOV     A,#A6H         ;/*reverse display on/off*/
                CALL    WR_INST         ;/*display normal*/
                
                MOV     A,#A8H         ;/*powersave mode*/
                CALL    WR_INST         ;/normal
                
                ;CALL    FILL_RAM_00     ;/*clear display*/
                
                MOV     A,#A2H         ;/*disable icon row*/
                CALL    WR_INST         ;
                
                MOV     A,#AFH         ;/*Display on*/
                CALL    WR_INST         ;
                
                MOV     A,#A4H         ;/*full off*/?????????????
                CALL    WR_INST         ;/*entire display on/off*/
                                 
                RET                     ;
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \: all ddram set "00"                               ;;;;;;;;
;:::::;:                                                          :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FILL_RAM_00:                            ;
                MOV     R2,#10110000B   ; PAGE ADDRESS = 0
$2:                                     ;
                MOV     A,R2            ;
                CALL    WR_INST         ;
                MOV     A,#00000000B    ;
                CALL    WR_INST         ;
                MOV     A,#00010000B    ;
                CALL    WR_INST         ;
                                        ;
                MOV     R4,#00H         ;
$1:                                     ;
                MOV     A,#00H          ;
                CALL    WR_DATA         ;
                MOV     A,#00H          ;
                CALL    WR_DATA         ;
                                        ;
                INC     R4              ;
                CJNE    R4,#128,$1      ;
                                        ;
                INC     R2              ;
                CJNE    R2,#11000000B,$2; (page=10111111)
                RET                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FILL_RAM_FF:                            ;
                MOV     R2,#10110000B   ; PAGE ADDRESS = 0
$21:                                     ;
                MOV     A,R2            ;
                CALL    WR_INST         ;
                MOV     A,#00000000B    ;
                CALL    WR_INST         ;
                MOV     A,#00010000B    ;
                CALL    WR_INST         ;
                                        ;
                MOV     R4,#00H         ;
$11:                                    ;
                MOV     A,#FFH          ;
                CALL    WR_DATA         ;
                MOV     A,#FFH          ;
                CALL    WR_DATA         ;
                                        ;
                INC     R4              ;
                CJNE    R4,#128,$11      ;
                                        ;
                INC     R2              ;
                CJNE    R2,#11000000B,$21; (page=10111111)
                RET                     ;                
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FILL_RAM_AA:                            ;
                MOV     R2,#10110000B   ; PAGE ADDRESS = 0
$22:                                    ;
                MOV     A,R2            ;
                CALL    WR_INST         ;
                MOV     A,#00000000B    ;
                CALL    WR_INST         ;
                MOV     A,#00010000B    ;
                CALL    WR_INST         ;
                                        ;
                MOV     R4,#00H         ;
$12:                                    ;
                MOV     A,#AAH          ;
                CALL    WR_DATA         ;
                MOV     A,#AAH          ;
                CALL    WR_DATA         ;
                                        ;
                INC     R4              ;
                CJNE    R4,#128,$12     ;
                                        ;
                INC     R2              ;
                CJNE    R2,#11000000B,$22; (page=10111111)
                RET                     ;                                
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FILL_RAM_55:                            ;
                MOV     R2,#10110000B   ; PAGE ADDRESS = 0
$23:                                    ;
                MOV     A,R2            ;
                CALL    WR_INST         ;
                MOV     A,#00000000B    ;
                CALL    WR_INST         ;
                MOV     A,#00010000B    ;
                CALL    WR_INST         ;
                                        ;
                MOV     R4,#00H         ;
$13:                                    ;
                MOV     A,#55H          ;
                CALL    WR_DATA         ;
                MOV     A,#55H          ;
                CALL    WR_DATA         ;
                                        ;
                INC     R4              ;
                CJNE    R4,#128,$13     ;
                                        ;
                INC     R2               ;
                CJNE    R2,#11000000B,$23 ; (page=10111111)
                RET                     ;                                
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FILL_RAM_10:                            ;
                MOV     R2,#10110000B   ;PAGE ADDRESS = 0
$24:                                    ;
                MOV     A,R2            ;
                CALL    WR_INST         ;
                MOV     A,#00000000B    ;
                CALL    WR_INST         ;
                MOV     A,#00010000B    ;
                CALL    WR_INST         ;
                                        ;
                MOV     R4,#00H         ;
$14:                                    ;
                MOV     A,#FFH          ;
                CALL    WR_DATA         ;                
                MOV     A,#FFH          ;
                CALL    WR_DATA         ;
                MOV     A,#00H          ;
                CALL    WR_DATA         ;                
                MOV     A,#00H          ;
                CALL    WR_DATA         ;
                                        ;
                INC     R4              ;
                CJNE    R4,#64,$14      ;
                                        ;
                INC     R2              ;
                CJNE    R2,#11000000B,$24; (page=10111111)
                RET                     ;                                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FILL_RAM_H:                             ;
                MOV     R2,#10110000B   ; PAGE ADDRESS = 0
$25:                                    ;
                MOV     A,R2            ;
                CALL    WR_INST         ;
                MOV     A,#00000000B    ;
                CALL    WR_INST         ;
                MOV     A,#00010000B    ;
                CALL    WR_INST         ;
                                        ;
                MOV     R4,#00H         ;
$15:                                    ;
                MOV     A,#AAH          ;
                CALL    WR_DATA         ;
                MOV     A,#AAH          ;
                CALL    WR_DATA         ;                
                                        ;
                INC     R4              ;
                CJNE    R4,#128,$15     ;
                                        ;
                INC     R2              ;
                CJNE    R2,#11000000B,$25; (page=10111111)
                RET                     ;                     
;;===========================================
SHOW_128_128:
                MOV     R2,#10110000B   ; PAGE ADDRESS = 0
                MOV     A,#00000000B    ;
                CALL    WR_INST         ;
                MOV     A,#00010000B    ;
                CALL    WR_INST         ;
lp2:                                    ;
                MOV     A,R2            ;
                CALL    WR_INST         ;                
                MOV     A,#00000000B    ;
                CALL    WR_INST         ;
                MOV     A,#00010000B    ;
                CALL    WR_INST         ;
                MOV     R6,#128         ;
lp1:                
                CLR     A               ;
                MOVC    A,@A+DPTR       ;
                CALL    WR_DATA         ;
                INC     DPTR            ;
                CLR     A               ;
                MOVC    A,@A+DPTR       ;
		CALL    WR_DATA         ;
		INC     DPTR            ;
		DJNZ    R6,lp1          ;
		
		INC     R2              ;
                CJNE    R2,#C0H,lp2     ;
		RET
;;===========================================
SLEEP_IN:
		MOV     A,#AEH          ;
                CALL    WR_INST         ;
                MOV     A,#A9H          ;
                CALL    WR_INST         ;
		RET                     ;
;;===========================================
SLEEP_OUT:
		MOV     A,#AFH          ;
                CALL    WR_INST         ;
                MOV     A,#E1H          ;
                CALL    WR_INST         ;
		RET                     ;		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \: WRITE_INST_I2C                                   ;;;;;;;;
;;;;;;;;   JѼ:                     XѼ:                ;;;;;;;;
;:::::;:                                                          :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WR_INST:
                PUSH    A               ;
                ;--------START----------;
                CLR     SDA             ; SDA=L
                SETB    SCL             ; SCL=H
                CLR     SCL             ; SCL=L
                ;-----SLAVE ADDRESS-----;
                MOV     A,#01111000B    ; 01111...  (SA1,SA0,RW)
                CALL    SEND_8BIT       ;
                CALL    CHECK_ACK       ;               
                ;-----COMMAND WORD------;
                MOV     A,#00000000B    ; ..000000  (Co , A0) A0=0 command
                CALL    SEND_8BIT       ;
                CALL    CHECK_ACK       ;                
                ;-----DATA -------------;
                ;MOV     A,I2C_DATA     ; DATA
                POP     A               ;
                CALL    SEND_8BIT       ;                
                CALL    CHECK_ACK       ;                
                ;--------STOP-----------;
                SETB    SCL             ; SCL=H
                CLR     SDA             ; SDA=L
                SETB    SDA             ; SDA=H
                RET                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \: WRITE_DATA_I2C                                   ;;;;;;;;
;;;;;;;;   JѼ:                     XѼ:                ;;;;;;;;
;:::::;:                                                          :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WR_DATA:
                PUSH    A               ;
                ;--------START----------;
                CLR     SDA             ; SDA=L
                SETB    SCL             ; SCL=H
                CLR     SCL             ; SCL=L
                ;-----SLAVE ADDRESS-----;
                MOV     A,#01111000B    ; 01111...  (SA1,SA0,RW)
                CALL    SEND_8BIT       ;
                CALL    CHECK_ACK       ;
                ;-----COMMAND WORD------;
                MOV     A,#01000000B    ; ..000000  (Co , A0) A0=1 data
                CALL    SEND_8BIT       ;
                CALL    CHECK_ACK       ;
                ;-----DATA -------------;
                ;MOV     A,I2C_DATA      ; DATA
                POP     A               ;
                CALL    SEND_8BIT       ;
                CALL    CHECK_ACK       ;
                ;--------STOP-----------;
                SETB    SCL             ; SCL=H
                CLR     SDA             ; SDA=L
                SETB    SDA             ; SDA=H
                RET                     ;
;;===========================================
WR_INST_1:	
		CALL	SEND_8BIT	;
		CALL    CHECK_ACK       ;
		RET			;

;;===========================================
START_1:	
                CLR     SDA             ; SDA=L
                SETB    SCL             ; SCL=H
                CLR     SCL             ; SCL=L
                ;-----SLAVE ADDRESS-----;
                MOV     A,#01111000B    ; 01111...  (SA1,SA0,RW)
                CALL    SEND_8BIT       ;
                CALL    CHECK_ACK       ;
                ;-----COMMAND WORD------;
                MOV     A,#10000000B    ; ..000000  (Co , A0) A0=0
                CALL    SEND_8BIT       ;
                CALL    CHECK_ACK       ;
		RET
;;===========================================
STOP_1:	
                SETB    SCL             ; SCL=H
                CLR     SDA             ; SDA=L
                SETB    SDA             ; SDA=H
                RET                     ;      				          
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \: CHECK_ACK                                        ;;;;;;;;
;;;;;;;;   JѼ:                     XѼ:                ;;;;;;;;
;:::::;:                                                          :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHECK_ACK:                              ;
                SETB    SDA             ; SDA=H
                SETB    SCL             ; SCL=H              
                JB      P1.6,$          ; IF "high" Waiting 
                nop			;
                CLR     SCL             ; SCL=H          
                RET                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \:  SEND_8BIT                                       ;;;;;;;;
;;;;;;;;   JѼ:                     XѼ:                ;;;;;;;;
;:::::;:                                                          :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SEND_8BIT:                              ;
                MOV     R7,#8           ;
RESEND:         RLC     A               ;
                JC      WRITE1          ;
WRITE0:         CLR     SDA             ;0
                SJMP    WRITESI         ;
WRITE1:         SETB    SDA             ;1
WRITESI:        SETB    SCL             ;
                CLR     SCL             ;
                DJNZ    R7,RESEND       ;
                RET
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \: delay                                            ;;;;;;;;
;:::::;:                                                          :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DELAY:                                  ;
                NOP                     ;
                NOP                     ;
                DJNZ    R7,DELAY        ; DELAY 4uS * R7
                RET                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \:10MS)                            ;;;;;;;;
;:::::;:    (R0)                                                  :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
COUNT_10MS:                             ;
             CLR     TF1                ;
             CLR     TR1                ;     12Mhz 1count=1.00us
             MOV     TL1,#<(65535-33333);                 16Mhz 1count=0.75us
             MOV     TH1,#>(65535-33333);                                40Mhz 1count=0.30us
             SETB    TR1                ;
             JNB     TF1,*              ;
             DJNZ    R0,COUNT_10MS      ;
             RET                        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \:  10MS                                        ;;;;;;;;
;:::::;:    (R0)                                                  :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DELAY_10MS:                             ;
                PUSH    0               ;PUSH R0
                MOV     R0,#1           ;
                CALL    COUNT_10MS      ;DELAY 10MS*1=10MS
                POP     0               ;POP  R0
                RET                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \: 100MS                                       ;;;;;;;;
;:::::;:    (R0)                                                  :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DELAY_100MS:                            ;
                PUSH    0               ;PUSH R0
                MOV     R0,#10          ;
                CALL    COUNT_10MS      ;DELAY 10MS*10=100MS
                POP     0               ;POP  R0
                RET                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \:  1SEC                                        ;;;;;;;;
;:::::;:    (R0)                                                  :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DELAY_1SEC:                             ;
                PUSH    0               ;PUSH R0
                MOV     R0,#100         ;
                CALL    COUNT_10MS      ;DELAY 10MS*100=1000MS
                POP     0               ;POP  R0
                RET                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   \:  2.5SEC                                      ;;;;;;;;
;:::::;:    (R0)                                                  :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DELAY_2SEC:                             ;
                PUSH    0               ;PUSH R0
                MOV     R0,#250         ;
                CALL    COUNT_10MS      ;DELAY 10MS*100=1000MS
                MOV     R0,#250         ;
                CALL    COUNT_10MS      ;DELAY 10MS*100=1000MS
                POP     0               ;POP  R0
                RET                     ;
;========================================================================
delay11:
		MOV     R0,#100
lpp:		
		DJNZ    R0,lpp
		SETB	SCL
		CLR	SCL		
		ret               
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;                                                          ;;;;;;;;
;;;;;;;;   Picture data                                           ;;;;;;;;
;:::::;:                                                          :::::::;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pp1:
	;DB          0, 16 ;<<----Row count(DB format)
        ;DB          1,  1 ;<<----Column count(DB format)
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,192,  0,224
        DB          0,224,  0,192,  0,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,  0,128,  0,192,  0,192
        DB          0,224,  0,112,  0,112,  0,112,  0, 56,  0, 56,  0, 56,  0, 56,  0, 56,  0, 24,  0, 28,  0, 28
        DB          0, 28,  0, 28,  0, 28,  0, 28,  0, 24,  0, 24,  0, 56,  0, 48,  0, 48,  0,112,  0, 96,  0,224
        DB          0,192,  0,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,128,  0,128,  0,128,  0,128,  0,128,  0,128,  0,128,  0,128,  0,128,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,  0,128,  0,192,  0,192,  0,192,  0,224
        DB          0,224,  0,113,  0, 63,  0, 31,  0, 14,  0, 14,  0,  7,  0,  3,  0,  1,  0,  1,  0,  1,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  1,  0,  3,  0,  7,  0, 14,  0, 28,  0, 56,  0,240,  0,224,  0,128,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,  0,192,  0,224,  0,224
        DB          0,112,  0, 56,  0, 56,  0, 28,  0, 28,  0, 14,  0,  6,  0,  6,  0,  7,  0,  7,  0,  3,  0,  3
        DB          0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3
        DB          0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  3,  0,  1,  0,  1,  0,  1,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  7,  0, 60,  0,240,  0,224
        DB          0,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,128,  0,240,  0,120,  0, 60,  0, 14,  0,  7,  0,  3,  0,  1,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0, 15
        DB          0, 63,  0,126,  0,248,  0,224,  0,192,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,192,  0,224,  0, 96,  0, 96,  0, 96,  0, 96,  0,224,  0,224,  0,224
        DB          0,240,  0,190,  0, 15,  0,  3,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 31,  0,255,  0,255,  0,112,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,  0,224
        DB          0,  0,  0,  0,  0,  1,  0,  7,  0, 31,  0,127,  0,252,  0,240,  0,192,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,240,  0,252,  0, 15,  0,  1,  0,128,  0,224,  0,240,  0,240,  0,240,  0,248,  0,255,  0,255
        DB          0,255,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,  0, 96,  0, 24,  0,  0,  0,  0,  0,  0
        DB          0,128,  0,224,  0, 56,  0, 14,  0,195,  0,224,  0,248,  0,252,  0,252,  0,126,  0, 31,  0, 63
        DB          0,255,  0,252,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,255,  0,255,  0,254,  0,192,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,  3,  0, 15,  0, 62,  0,120,  0,240,  0,227,  0,247,  0,255,  0,255,  0,255,  0,255,  0,255
        DB          0,255,  0,252,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,192,  0,112,  0, 28,  0,  7,  0,  1,  0,128,  0,192,128,112,192, 60, 96,158
        DB         96, 31, 48, 79, 48, 15, 16, 47, 16, 47, 16, 47, 48,  9, 16, 47, 48, 15, 16, 40, 28, 34, 12, 19
        DB          6,  9,  6,  1,  2,  5,  2,  5,  2,  1,  3,  0,  3,  0,  1,  2,  3,  4,  3,  4,  6,  9,  8, 20
        DB         16,232,192, 48,  0,224,  0,128,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1
        DB          0, 15,  0, 63,  0,126,  0,240,  0,224,  0,192,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,192
        DB          0,252,  0, 63,  0,  1,  0,192,176, 64,208,200,248,196,252,139,  7,  0,  1,  2,  0,  1,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  8, 20,  0, 12,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,  0,128,128, 64,192,160,224,192
        DB        224,240,241,  2,  7,202, 28,235,240,206,  0,248,  0,128,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  0, 15,  0, 31,  0, 62,  0,124,  0,120,  0,240,  0,224
        DB          0,224,  0,192,  0,128,  0,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,255
        DB          0,255,  0,  0,  0,  0,  0,  0,  1, 18,  3,253,  3,253, 15,247, 56,196,112,160,224,  0,192, 32
        DB        192,  0,128, 64,128, 64,128,  0,  0,128,  0,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,224, 28,  0,167,120,135,254,253,255,255,255,127,127,255
        DB        127,191,159,111,192, 39,112,142, 15,119,  6, 57,  0,  3,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1
        DB          0,  1,  0,  3,  0,  3,  0,  3,  0,  7,  0,  7,  0,  7,  0,  7,  0,  6,  0,  6,  0, 14,  0, 14
        DB          0, 12,  0, 28,  0, 28,  0, 28,  0, 24,  0, 56,  0, 56,  0, 56,  0,112,  0,240,  0,224,  0,192
        DB          0,192,  0,128,  0,128,  0,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,  0,192,  0,192,  0,255
        DB          0,255,  0,240,  0,128,  0,  0,  0,  0,  0,  7,  0, 15,  0, 31,  0, 31,  0, 63,  0, 63,  0, 63
        DB          1, 30,  1, 30,  1, 14,  3, 12,  3, 12,  3, 12,131,  4, 66,181, 62,112, 60,  2, 48,  0, 48, 64
        DB         32,112,112, 32,248,244,252,  2,  6,248,  3,  4,  3,  4,  0,  6,  0, 15,  4, 11,  4, 11,  6,  1
        DB          2,  5,  1,  2,  1,  2,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1
        DB          0,  1,  0,  3,  0,  3,  0,  3,  0,  7,  0, 15,  0, 31,  0,254,  0,254,  0,224,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128
        DB          0,192,  0,240,  0,112,  0, 56,  0, 28,  0, 28,  0, 14,  0,  7,  0,  7,  0,  3,  0,  1,  0,  1
        DB          0,  1,  0,  1,  0,  7,  0,  7,  0, 14,  0, 12,  0, 28,  0, 24,  0, 56,  0, 56,  0, 56,  0, 60
        DB          0, 28,  0, 28,  0, 28,  0,254, 12,242,  6,  9,  1,  2,  0,  0,  0,  0,  0,192,  0, 24,  0,  0
        DB          0,  0,  0,  0,  1,194,255,224,252,195,192, 60,  0,192,128, 64,  0,192,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0, 14,  0, 14,  0,158,  0,254,  0,254,  0,127,  0,127,  0,127,  0,126,  0,124
        DB          0,124,  0,124,  0,124,  0,248,  0,248,  0,248,  0,248,  0,248,  0,248,  0,248,  0,248,  0,255
        DB          0,255,  0,225,  0,224,  0,224,  0,192,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB        128, 64,192,  0,  0,192,128, 95, 24,229,112,160, 64,160,128, 64,  0,192, 56, 71, 64,160,  0,192
        DB         96,128, 64, 32, 25, 54, 15, 23, 31, 15, 31, 12, 12, 19,  6,  9,  3,  4,  2,  5,  4,250,248,  4
        DB          0,248,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        DB        224,192,224,192,224,192,224,192,224,192,224,  0,  0,224,  0,224,  0,160,  0,224,  0,224,  0,224
        DB          0,224,128, 96,128, 96,224,  0,224,192,160, 64,  0,224, 32,192,  0,224, 96,128, 96,128, 96,144
        DB        128, 96,128, 96,160, 64,  0,224,  0,224,  0,224,  0,224,  0,224,224,  0,224,128,224,128,224,  0
        DB         32,192, 32,192, 32,192, 32,192, 32,192, 32,192,224,  0,224,  0,224,  0,224,  0,192, 32,128, 96
        DB         32,208, 48,200, 32,222, 32,223, 32,195, 32,193,224,  0, 96,128, 32,192, 32,192, 32,192, 32,192
        DB         32,192,224,  0,224,  0,160, 64,224,  0,160, 64,224,  0,224, 64,224,  1, 32,193, 32,195, 32,223
        DB         48,207, 48,207,224, 23,160, 67, 96,131,  0,224,224,  0,224,  0,224,  0,160, 64,160, 64, 32,192
        DB         32,192, 32,192, 32,192, 32,192,224,  0,224,  0, 32,192, 32,208, 32,192, 32,192, 32,192,224,  7
        DB        249,198,224, 88,192,224,128, 64,  0,129,  3,  4,  6,  9,  4, 11,  0,  1,  0,  0,  0,  0,  0,  0
        DB         62,  1, 64,166,192,134,  0, 62,  6,  9,  0,135,  0,  0,  0,128,240,  0,240, 44,254,129,227,252
        DB        224,211,224,192,224,192,224,192,224,192,224,192,224,192,  0,  0 ;<<----Line end 
        DB          1,  3,  1,  3,  1,  3,  1,  3,  1,  3,  1,  3,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2
        DB          1,  2,  1,  3,  1,  3,  3,  1,  1,  3,  1,  3,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2
        DB          1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  3,  1,  3,  1,  3,  1,  2
        DB          1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  3,  3, 16,  3, 28,  3, 28,  3,  0,  3,  0
        DB          1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2
        DB          1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  3,  1,  2,  1,  2,  3,  0,  1,  2
        DB          1,  2,  3,  0,  3, 29,  3, 28,  3, 24,  1,  2,  1,  2,  1,  3,  1,  3,  1,  2,  1,  2,  1,  2
        DB          1,  2,  1,  2,  1,  2,  1,  2,  1,  2,  1,  3,  1,  2,  1,  2,  1,  2,  1,  2,  3,  0,  1,  3
        DB          1,  3,  1,  2,  1,  3,  1,  3,  3,  0,  2,  5,  6,  0,  4, 14, 12,  2, 12, 16,  8, 28,  8, 20
        DB          8, 20, 12, 18,  7, 11,  6,  9,  4, 10,  6,  1,  3,  6,  3,  4,  3,  0,  3,  1,  1,  3,  1,  3
        DB          1,  3,  1,  3,  1,  3,  1,  3,  1,  3,  1,  3,  1,  3,  0,  0 ;<<----Line end 
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        DB          0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;<<----Line end 
        END
